"use strict";
// Generated by morphir-elm
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Morphir_IR_Literal = void 0;
const codecs = __importStar(require("./../../morphir/internal/Codecs"));
var Morphir_IR_Literal;
(function (Morphir_IR_Literal) {
    function decodeLiteral(input) {
        let kind = codecs.parseKindFromCustomTypeInput(input);
        switch (kind) {
            case "BoolLiteral":
                return decodeBoolLiteral(input);
            case "CharLiteral":
                return decodeCharLiteral(input);
            case "DecimalLiteral":
                return decodeDecimalLiteral(input);
            case "FloatLiteral":
                return decodeFloatLiteral(input);
            case "StringLiteral":
                return decodeStringLiteral(input);
            case "WholeNumberLiteral":
                return decodeWholeNumberLiteral(input);
        }
        codecs.raiseDecodeErrorFromCustomType("Literal", kind);
    }
    Morphir_IR_Literal.decodeLiteral = decodeLiteral;
    function encodeLiteral(value) {
        switch (value.kind) {
            case "BoolLiteral":
                return encodeBoolLiteral(value);
            case "CharLiteral":
                return encodeCharLiteral(value);
            case "DecimalLiteral":
                return encodeDecimalLiteral(value);
            case "FloatLiteral":
                return encodeFloatLiteral(value);
            case "StringLiteral":
                return encodeStringLiteral(value);
            case "WholeNumberLiteral":
                return encodeWholeNumberLiteral(value);
        }
    }
    Morphir_IR_Literal.encodeLiteral = encodeLiteral;
    class BoolLiteral {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "BoolLiteral";
        }
    }
    Morphir_IR_Literal.BoolLiteral = BoolLiteral;
    function decodeBoolLiteral(input) {
        codecs.preprocessCustomTypeVariant("BoolLiteral", 1, input);
        return new BoolLiteral(codecs.decodeBoolean(input[1]));
    }
    Morphir_IR_Literal.decodeBoolLiteral = decodeBoolLiteral;
    function encodeBoolLiteral(value) {
        return [value.kind, codecs.encodeBoolean(value.arg1)];
    }
    Morphir_IR_Literal.encodeBoolLiteral = encodeBoolLiteral;
    class CharLiteral {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "CharLiteral";
        }
    }
    Morphir_IR_Literal.CharLiteral = CharLiteral;
    function decodeCharLiteral(input) {
        codecs.preprocessCustomTypeVariant("CharLiteral", 1, input);
        return new CharLiteral(codecs.decodeChar(input[1]));
    }
    Morphir_IR_Literal.decodeCharLiteral = decodeCharLiteral;
    function encodeCharLiteral(value) {
        return [value.kind, codecs.encodeChar(value.arg1)];
    }
    Morphir_IR_Literal.encodeCharLiteral = encodeCharLiteral;
    class DecimalLiteral {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "DecimalLiteral";
        }
    }
    Morphir_IR_Literal.DecimalLiteral = DecimalLiteral;
    function decodeDecimalLiteral(input) {
        codecs.preprocessCustomTypeVariant("DecimalLiteral", 1, input);
        return new DecimalLiteral(Morphir_SDK_Decimal.decodeDecimal(input[1]));
    }
    Morphir_IR_Literal.decodeDecimalLiteral = decodeDecimalLiteral;
    function encodeDecimalLiteral(value) {
        return [value.kind, Morphir_SDK_Decimal.encodeDecimal(value.arg1)];
    }
    Morphir_IR_Literal.encodeDecimalLiteral = encodeDecimalLiteral;
    class FloatLiteral {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "FloatLiteral";
        }
    }
    Morphir_IR_Literal.FloatLiteral = FloatLiteral;
    function decodeFloatLiteral(input) {
        codecs.preprocessCustomTypeVariant("FloatLiteral", 1, input);
        return new FloatLiteral(codecs.decodeFloat(input[1]));
    }
    Morphir_IR_Literal.decodeFloatLiteral = decodeFloatLiteral;
    function encodeFloatLiteral(value) {
        return [value.kind, codecs.encodeFloat(value.arg1)];
    }
    Morphir_IR_Literal.encodeFloatLiteral = encodeFloatLiteral;
    class StringLiteral {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "StringLiteral";
        }
    }
    Morphir_IR_Literal.StringLiteral = StringLiteral;
    function decodeStringLiteral(input) {
        codecs.preprocessCustomTypeVariant("StringLiteral", 1, input);
        return new StringLiteral(codecs.decodeString(input[1]));
    }
    Morphir_IR_Literal.decodeStringLiteral = decodeStringLiteral;
    function encodeStringLiteral(value) {
        return [value.kind, codecs.encodeString(value.arg1)];
    }
    Morphir_IR_Literal.encodeStringLiteral = encodeStringLiteral;
    class WholeNumberLiteral {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "WholeNumberLiteral";
        }
    }
    Morphir_IR_Literal.WholeNumberLiteral = WholeNumberLiteral;
    function decodeWholeNumberLiteral(input) {
        codecs.preprocessCustomTypeVariant("WholeNumberLiteral", 1, input);
        return new WholeNumberLiteral(codecs.decodeInt(input[1]));
    }
    Morphir_IR_Literal.decodeWholeNumberLiteral = decodeWholeNumberLiteral;
    function encodeWholeNumberLiteral(value) {
        return [value.kind, codecs.encodeInt(value.arg1)];
    }
    Morphir_IR_Literal.encodeWholeNumberLiteral = encodeWholeNumberLiteral;
})(Morphir_IR_Literal = exports.Morphir_IR_Literal || (exports.Morphir_IR_Literal = {}));
