"use strict";
// Generated by morphir-elm
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Morphir_IR_Value = void 0;
const codecs = __importStar(require("./../../morphir/internal/Codecs"));
const FQName_1 = require("./../../morphir/ir/FQName");
const Literal_1 = require("./../../morphir/ir/Literal");
const Name_1 = require("./../../morphir/ir/Name");
const Type_1 = require("./../../morphir/ir/Type");
var Morphir_IR_Value;
(function (Morphir_IR_Value) {
    function decodeDefinition(decodeTa, decodeVa, input) {
        return codecs.decodeRecord(codecs.buildCodecMap([
            [
                "inputTypes",
                codecs.decodeList.bind(null, codecs.decodeTuple.bind(null, [
                    Name_1.Morphir_IR_Name.decodeName,
                    decodeVa,
                    Type_1.Morphir_IR_Type.decodeType.bind(null, decodeTa),
                ])),
            ],
            ["outputType", Type_1.Morphir_IR_Type.decodeType.bind(null, decodeTa)],
            ["body", Morphir_IR_Value.decodeValue.bind(null, decodeTa, decodeVa)],
        ]), input);
    }
    Morphir_IR_Value.decodeDefinition = decodeDefinition;
    function encodeDefinition(encodeTa, encodeVa, value) {
        return codecs.encodeRecord(codecs.buildCodecMap([
            [
                "inputTypes",
                codecs.encodeList.bind(null, codecs.encodeTuple.bind(null, [
                    Name_1.Morphir_IR_Name.encodeName,
                    encodeVa,
                    Type_1.Morphir_IR_Type.encodeType.bind(null, encodeTa),
                ])),
            ],
            ["outputType", Type_1.Morphir_IR_Type.encodeType.bind(null, encodeTa)],
            ["body", Morphir_IR_Value.encodeValue.bind(null, encodeTa, encodeVa)],
        ]), value);
    }
    Morphir_IR_Value.encodeDefinition = encodeDefinition;
    function decodePattern(decodeA, input) {
        let kind = codecs.parseKindFromCustomTypeInput(input);
        switch (kind) {
            case "AsPattern":
                return decodeAsPattern(decodeA, input);
            case "ConstructorPattern":
                return decodeConstructorPattern(decodeA, input);
            case "EmptyListPattern":
                return decodeEmptyListPattern(decodeA, input);
            case "HeadTailPattern":
                return decodeHeadTailPattern(decodeA, input);
            case "LiteralPattern":
                return decodeLiteralPattern(decodeA, input);
            case "TuplePattern":
                return decodeTuplePattern(decodeA, input);
            case "UnitPattern":
                return decodeUnitPattern(decodeA, input);
            case "WildcardPattern":
                return decodeWildcardPattern(decodeA, input);
        }
        codecs.raiseDecodeErrorFromCustomType("Pattern", kind);
    }
    Morphir_IR_Value.decodePattern = decodePattern;
    function encodePattern(encodeA, value) {
        switch (value.kind) {
            case "AsPattern":
                return encodeAsPattern(encodeA, value);
            case "ConstructorPattern":
                return encodeConstructorPattern(encodeA, value);
            case "EmptyListPattern":
                return encodeEmptyListPattern(encodeA, value);
            case "HeadTailPattern":
                return encodeHeadTailPattern(encodeA, value);
            case "LiteralPattern":
                return encodeLiteralPattern(encodeA, value);
            case "TuplePattern":
                return encodeTuplePattern(encodeA, value);
            case "UnitPattern":
                return encodeUnitPattern(encodeA, value);
            case "WildcardPattern":
                return encodeWildcardPattern(encodeA, value);
        }
    }
    Morphir_IR_Value.encodePattern = encodePattern;
    class AsPattern {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "AsPattern";
        }
    }
    Morphir_IR_Value.AsPattern = AsPattern;
    function decodeAsPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("AsPattern", 3, input);
        return new AsPattern(decodeA(input[1]), Morphir_IR_Value.decodePattern(decodeA, input[2]), Name_1.Morphir_IR_Name.decodeName(input[3]));
    }
    Morphir_IR_Value.decodeAsPattern = decodeAsPattern;
    function encodeAsPattern(encodeA, value) {
        return [
            value.kind,
            encodeA(value.arg1),
            Morphir_IR_Value.encodePattern(encodeA, value.arg2),
            Name_1.Morphir_IR_Name.encodeName(value.arg3),
        ];
    }
    Morphir_IR_Value.encodeAsPattern = encodeAsPattern;
    class ConstructorPattern {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "ConstructorPattern";
        }
    }
    Morphir_IR_Value.ConstructorPattern = ConstructorPattern;
    function decodeConstructorPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("ConstructorPattern", 3, input);
        return new ConstructorPattern(decodeA(input[1]), FQName_1.Morphir_IR_FQName.decodeFQName(input[2]), codecs.decodeList(Morphir_IR_Value.decodePattern.bind(null, decodeA), input[3]));
    }
    Morphir_IR_Value.decodeConstructorPattern = decodeConstructorPattern;
    function encodeConstructorPattern(encodeA, value) {
        return [
            value.kind,
            encodeA(value.arg1),
            FQName_1.Morphir_IR_FQName.encodeFQName(value.arg2),
            codecs.encodeList(Morphir_IR_Value.encodePattern.bind(null, encodeA), value.arg3),
        ];
    }
    Morphir_IR_Value.encodeConstructorPattern = encodeConstructorPattern;
    class EmptyListPattern {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "EmptyListPattern";
        }
    }
    Morphir_IR_Value.EmptyListPattern = EmptyListPattern;
    function decodeEmptyListPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("EmptyListPattern", 1, input);
        return new EmptyListPattern(decodeA(input[1]));
    }
    Morphir_IR_Value.decodeEmptyListPattern = decodeEmptyListPattern;
    function encodeEmptyListPattern(encodeA, value) {
        return [value.kind, encodeA(value.arg1)];
    }
    Morphir_IR_Value.encodeEmptyListPattern = encodeEmptyListPattern;
    class HeadTailPattern {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "HeadTailPattern";
        }
    }
    Morphir_IR_Value.HeadTailPattern = HeadTailPattern;
    function decodeHeadTailPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("HeadTailPattern", 3, input);
        return new HeadTailPattern(decodeA(input[1]), Morphir_IR_Value.decodePattern(decodeA, input[2]), Morphir_IR_Value.decodePattern(decodeA, input[3]));
    }
    Morphir_IR_Value.decodeHeadTailPattern = decodeHeadTailPattern;
    function encodeHeadTailPattern(encodeA, value) {
        return [
            value.kind,
            encodeA(value.arg1),
            Morphir_IR_Value.encodePattern(encodeA, value.arg2),
            Morphir_IR_Value.encodePattern(encodeA, value.arg3),
        ];
    }
    Morphir_IR_Value.encodeHeadTailPattern = encodeHeadTailPattern;
    class LiteralPattern {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "LiteralPattern";
        }
    }
    Morphir_IR_Value.LiteralPattern = LiteralPattern;
    function decodeLiteralPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("LiteralPattern", 2, input);
        return new LiteralPattern(decodeA(input[1]), Literal_1.Morphir_IR_Literal.decodeLiteral(input[2]));
    }
    Morphir_IR_Value.decodeLiteralPattern = decodeLiteralPattern;
    function encodeLiteralPattern(encodeA, value) {
        return [
            value.kind,
            encodeA(value.arg1),
            Literal_1.Morphir_IR_Literal.encodeLiteral(value.arg2),
        ];
    }
    Morphir_IR_Value.encodeLiteralPattern = encodeLiteralPattern;
    class TuplePattern {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "TuplePattern";
        }
    }
    Morphir_IR_Value.TuplePattern = TuplePattern;
    function decodeTuplePattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("TuplePattern", 2, input);
        return new TuplePattern(decodeA(input[1]), codecs.decodeList(Morphir_IR_Value.decodePattern.bind(null, decodeA), input[2]));
    }
    Morphir_IR_Value.decodeTuplePattern = decodeTuplePattern;
    function encodeTuplePattern(encodeA, value) {
        return [
            value.kind,
            encodeA(value.arg1),
            codecs.encodeList(Morphir_IR_Value.encodePattern.bind(null, encodeA), value.arg2),
        ];
    }
    Morphir_IR_Value.encodeTuplePattern = encodeTuplePattern;
    class UnitPattern {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "UnitPattern";
        }
    }
    Morphir_IR_Value.UnitPattern = UnitPattern;
    function decodeUnitPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("UnitPattern", 1, input);
        return new UnitPattern(decodeA(input[1]));
    }
    Morphir_IR_Value.decodeUnitPattern = decodeUnitPattern;
    function encodeUnitPattern(encodeA, value) {
        return [value.kind, encodeA(value.arg1)];
    }
    Morphir_IR_Value.encodeUnitPattern = encodeUnitPattern;
    class WildcardPattern {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "WildcardPattern";
        }
    }
    Morphir_IR_Value.WildcardPattern = WildcardPattern;
    function decodeWildcardPattern(decodeA, input) {
        codecs.preprocessCustomTypeVariant("WildcardPattern", 1, input);
        return new WildcardPattern(decodeA(input[1]));
    }
    Morphir_IR_Value.decodeWildcardPattern = decodeWildcardPattern;
    function encodeWildcardPattern(encodeA, value) {
        return [value.kind, encodeA(value.arg1)];
    }
    Morphir_IR_Value.encodeWildcardPattern = encodeWildcardPattern;
    function decodeRawValue(input) {
        return Morphir_IR_Value.decodeValue(codecs.decodeUnit, codecs.decodeUnit, input);
    }
    Morphir_IR_Value.decodeRawValue = decodeRawValue;
    function encodeRawValue(value) {
        return Morphir_IR_Value.encodeValue(codecs.encodeUnit, codecs.encodeUnit, value);
    }
    Morphir_IR_Value.encodeRawValue = encodeRawValue;
    function decodeSpecification(decodeTa, input) {
        return codecs.decodeRecord(codecs.buildCodecMap([
            [
                "inputs",
                codecs.decodeList.bind(null, codecs.decodeTuple.bind(null, [
                    Name_1.Morphir_IR_Name.decodeName,
                    Type_1.Morphir_IR_Type.decodeType.bind(null, decodeTa),
                ])),
            ],
            ["output", Type_1.Morphir_IR_Type.decodeType.bind(null, decodeTa)],
        ]), input);
    }
    Morphir_IR_Value.decodeSpecification = decodeSpecification;
    function encodeSpecification(encodeTa, value) {
        return codecs.encodeRecord(codecs.buildCodecMap([
            [
                "inputs",
                codecs.encodeList.bind(null, codecs.encodeTuple.bind(null, [
                    Name_1.Morphir_IR_Name.encodeName,
                    Type_1.Morphir_IR_Type.encodeType.bind(null, encodeTa),
                ])),
            ],
            ["output", Type_1.Morphir_IR_Type.encodeType.bind(null, encodeTa)],
        ]), value);
    }
    Morphir_IR_Value.encodeSpecification = encodeSpecification;
    function decodeTypedValue(input) {
        return Morphir_IR_Value.decodeValue(codecs.decodeUnit, Type_1.Morphir_IR_Type.decodeType.bind(null, codecs.decodeUnit), input);
    }
    Morphir_IR_Value.decodeTypedValue = decodeTypedValue;
    function encodeTypedValue(value) {
        return Morphir_IR_Value.encodeValue(codecs.encodeUnit, Type_1.Morphir_IR_Type.encodeType.bind(null, codecs.encodeUnit), value);
    }
    Morphir_IR_Value.encodeTypedValue = encodeTypedValue;
    function decodeValue(decodeTa, decodeVa, input) {
        let kind = codecs.parseKindFromCustomTypeInput(input);
        switch (kind) {
            case "Apply":
                return decodeApply(decodeVa, decodeTa, input);
            case "Constructor":
                return decodeConstructor(decodeVa, input);
            case "Destructure":
                return decodeDestructure(decodeVa, decodeTa, input);
            case "Field":
                return decodeField(decodeVa, decodeTa, input);
            case "FieldFunction":
                return decodeFieldFunction(decodeVa, input);
            case "IfThenElse":
                return decodeIfThenElse(decodeVa, decodeTa, input);
            case "Lambda":
                return decodeLambda(decodeVa, decodeTa, input);
            case "LetDefinition":
                return decodeLetDefinition(decodeVa, decodeTa, input);
            case "LetRecursion":
                return decodeLetRecursion(decodeVa, decodeTa, input);
            case "List":
                return decodeList(decodeVa, decodeTa, input);
            case "Literal":
                return decodeLiteral(decodeVa, input);
            case "PatternMatch":
                return decodePatternMatch(decodeVa, decodeTa, input);
            case "Record":
                return decodeRecord(decodeVa, decodeTa, input);
            case "Reference":
                return decodeReference(decodeVa, input);
            case "Tuple":
                return decodeTuple(decodeVa, decodeTa, input);
            case "Unit":
                return decodeUnit(decodeVa, input);
            case "UpdateRecord":
                return decodeUpdateRecord(decodeVa, decodeTa, input);
            case "Variable":
                return decodeVariable(decodeVa, input);
        }
        codecs.raiseDecodeErrorFromCustomType("Value", kind);
    }
    Morphir_IR_Value.decodeValue = decodeValue;
    function encodeValue(encodeTa, encodeVa, value) {
        switch (value.kind) {
            case "Apply":
                return encodeApply(encodeVa, encodeTa, value);
            case "Constructor":
                return encodeConstructor(encodeVa, value);
            case "Destructure":
                return encodeDestructure(encodeVa, encodeTa, value);
            case "Field":
                return encodeField(encodeVa, encodeTa, value);
            case "FieldFunction":
                return encodeFieldFunction(encodeVa, value);
            case "IfThenElse":
                return encodeIfThenElse(encodeVa, encodeTa, value);
            case "Lambda":
                return encodeLambda(encodeVa, encodeTa, value);
            case "LetDefinition":
                return encodeLetDefinition(encodeVa, encodeTa, value);
            case "LetRecursion":
                return encodeLetRecursion(encodeVa, encodeTa, value);
            case "List":
                return encodeList(encodeVa, encodeTa, value);
            case "Literal":
                return encodeLiteral(encodeVa, value);
            case "PatternMatch":
                return encodePatternMatch(encodeVa, encodeTa, value);
            case "Record":
                return encodeRecord(encodeVa, encodeTa, value);
            case "Reference":
                return encodeReference(encodeVa, value);
            case "Tuple":
                return encodeTuple(encodeVa, encodeTa, value);
            case "Unit":
                return encodeUnit(encodeVa, value);
            case "UpdateRecord":
                return encodeUpdateRecord(encodeVa, encodeTa, value);
            case "Variable":
                return encodeVariable(encodeVa, value);
        }
    }
    Morphir_IR_Value.encodeValue = encodeValue;
    class Apply {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "Apply";
        }
    }
    Morphir_IR_Value.Apply = Apply;
    function decodeApply(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("Apply", 3, input);
        return new Apply(decodeVa(input[1]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[2]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[3]));
    }
    Morphir_IR_Value.decodeApply = decodeApply;
    function encodeApply(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg2),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg3),
        ];
    }
    Morphir_IR_Value.encodeApply = encodeApply;
    class Constructor {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "Constructor";
        }
    }
    Morphir_IR_Value.Constructor = Constructor;
    function decodeConstructor(decodeVa, input) {
        codecs.preprocessCustomTypeVariant("Constructor", 2, input);
        return new Constructor(decodeVa(input[1]), FQName_1.Morphir_IR_FQName.decodeFQName(input[2]));
    }
    Morphir_IR_Value.decodeConstructor = decodeConstructor;
    function encodeConstructor(encodeVa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            FQName_1.Morphir_IR_FQName.encodeFQName(value.arg2),
        ];
    }
    Morphir_IR_Value.encodeConstructor = encodeConstructor;
    class Destructure {
        constructor(arg1, arg2, arg3, arg4) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.arg4 = arg4;
            this.kind = "Destructure";
        }
    }
    Morphir_IR_Value.Destructure = Destructure;
    function decodeDestructure(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("Destructure", 4, input);
        return new Destructure(decodeVa(input[1]), Morphir_IR_Value.decodePattern(decodeVa, input[2]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[3]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[4]));
    }
    Morphir_IR_Value.decodeDestructure = decodeDestructure;
    function encodeDestructure(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodePattern(encodeVa, value.arg2),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg3),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg4),
        ];
    }
    Morphir_IR_Value.encodeDestructure = encodeDestructure;
    class Field {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "Field";
        }
    }
    Morphir_IR_Value.Field = Field;
    function decodeField(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("Field", 3, input);
        return new Field(decodeVa(input[1]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[2]), Name_1.Morphir_IR_Name.decodeName(input[3]));
    }
    Morphir_IR_Value.decodeField = decodeField;
    function encodeField(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg2),
            Name_1.Morphir_IR_Name.encodeName(value.arg3),
        ];
    }
    Morphir_IR_Value.encodeField = encodeField;
    class FieldFunction {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "FieldFunction";
        }
    }
    Morphir_IR_Value.FieldFunction = FieldFunction;
    function decodeFieldFunction(decodeVa, input) {
        codecs.preprocessCustomTypeVariant("FieldFunction", 2, input);
        return new FieldFunction(decodeVa(input[1]), Name_1.Morphir_IR_Name.decodeName(input[2]));
    }
    Morphir_IR_Value.decodeFieldFunction = decodeFieldFunction;
    function encodeFieldFunction(encodeVa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Name_1.Morphir_IR_Name.encodeName(value.arg2),
        ];
    }
    Morphir_IR_Value.encodeFieldFunction = encodeFieldFunction;
    class IfThenElse {
        constructor(arg1, arg2, arg3, arg4) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.arg4 = arg4;
            this.kind = "IfThenElse";
        }
    }
    Morphir_IR_Value.IfThenElse = IfThenElse;
    function decodeIfThenElse(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("IfThenElse", 4, input);
        return new IfThenElse(decodeVa(input[1]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[2]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[3]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[4]));
    }
    Morphir_IR_Value.decodeIfThenElse = decodeIfThenElse;
    function encodeIfThenElse(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg2),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg3),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg4),
        ];
    }
    Morphir_IR_Value.encodeIfThenElse = encodeIfThenElse;
    class Lambda {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "Lambda";
        }
    }
    Morphir_IR_Value.Lambda = Lambda;
    function decodeLambda(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("Lambda", 3, input);
        return new Lambda(decodeVa(input[1]), Morphir_IR_Value.decodePattern(decodeVa, input[2]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[3]));
    }
    Morphir_IR_Value.decodeLambda = decodeLambda;
    function encodeLambda(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodePattern(encodeVa, value.arg2),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg3),
        ];
    }
    Morphir_IR_Value.encodeLambda = encodeLambda;
    class LetDefinition {
        constructor(arg1, arg2, arg3, arg4) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.arg4 = arg4;
            this.kind = "LetDefinition";
        }
    }
    Morphir_IR_Value.LetDefinition = LetDefinition;
    function decodeLetDefinition(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("LetDefinition", 4, input);
        return new LetDefinition(decodeVa(input[1]), Name_1.Morphir_IR_Name.decodeName(input[2]), Morphir_IR_Value.decodeDefinition(decodeTa, decodeVa, input[3]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[4]));
    }
    Morphir_IR_Value.decodeLetDefinition = decodeLetDefinition;
    function encodeLetDefinition(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Name_1.Morphir_IR_Name.encodeName(value.arg2),
            Morphir_IR_Value.encodeDefinition(encodeTa, encodeVa, value.arg3),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg4),
        ];
    }
    Morphir_IR_Value.encodeLetDefinition = encodeLetDefinition;
    class LetRecursion {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "LetRecursion";
        }
    }
    Morphir_IR_Value.LetRecursion = LetRecursion;
    function decodeLetRecursion(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("LetRecursion", 3, input);
        return new LetRecursion(decodeVa(input[1]), codecs.decodeDict(Name_1.Morphir_IR_Name.decodeName, Morphir_IR_Value.decodeDefinition.bind(null, decodeTa, decodeVa), input[2]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[3]));
    }
    Morphir_IR_Value.decodeLetRecursion = decodeLetRecursion;
    function encodeLetRecursion(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            codecs.encodeDict(Name_1.Morphir_IR_Name.encodeName, Morphir_IR_Value.encodeDefinition.bind(null, encodeTa, encodeVa), value.arg2),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg3),
        ];
    }
    Morphir_IR_Value.encodeLetRecursion = encodeLetRecursion;
    class List {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "List";
        }
    }
    Morphir_IR_Value.List = List;
    function decodeList(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("List", 2, input);
        return new List(decodeVa(input[1]), codecs.decodeList(Morphir_IR_Value.decodeValue.bind(null, decodeTa, decodeVa), input[2]));
    }
    Morphir_IR_Value.decodeList = decodeList;
    function encodeList(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            codecs.encodeList(Morphir_IR_Value.encodeValue.bind(null, encodeTa, encodeVa), value.arg2),
        ];
    }
    Morphir_IR_Value.encodeList = encodeList;
    class Literal {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "Literal";
        }
    }
    Morphir_IR_Value.Literal = Literal;
    function decodeLiteral(decodeVa, input) {
        codecs.preprocessCustomTypeVariant("Literal", 2, input);
        return new Literal(decodeVa(input[1]), Literal_1.Morphir_IR_Literal.decodeLiteral(input[2]));
    }
    Morphir_IR_Value.decodeLiteral = decodeLiteral;
    function encodeLiteral(encodeVa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Literal_1.Morphir_IR_Literal.encodeLiteral(value.arg2),
        ];
    }
    Morphir_IR_Value.encodeLiteral = encodeLiteral;
    class PatternMatch {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "PatternMatch";
        }
    }
    Morphir_IR_Value.PatternMatch = PatternMatch;
    function decodePatternMatch(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("PatternMatch", 3, input);
        return new PatternMatch(decodeVa(input[1]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[2]), codecs.decodeList(codecs.decodeTuple.bind(null, [
            Morphir_IR_Value.decodePattern.bind(null, decodeVa),
            Morphir_IR_Value.decodeValue.bind(null, decodeTa, decodeVa),
        ]), input[3]));
    }
    Morphir_IR_Value.decodePatternMatch = decodePatternMatch;
    function encodePatternMatch(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg2),
            codecs.encodeList(codecs.encodeTuple.bind(null, [
                Morphir_IR_Value.encodePattern.bind(null, encodeVa),
                Morphir_IR_Value.encodeValue.bind(null, encodeTa, encodeVa),
            ]), value.arg3),
        ];
    }
    Morphir_IR_Value.encodePatternMatch = encodePatternMatch;
    class Record {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "Record";
        }
    }
    Morphir_IR_Value.Record = Record;
    function decodeRecord(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("Record", 2, input);
        return new Record(decodeVa(input[1]), codecs.decodeDict(Name_1.Morphir_IR_Name.decodeName, Morphir_IR_Value.decodeValue.bind(null, decodeTa, decodeVa), input[2]));
    }
    Morphir_IR_Value.decodeRecord = decodeRecord;
    function encodeRecord(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            codecs.encodeDict(Name_1.Morphir_IR_Name.encodeName, Morphir_IR_Value.encodeValue.bind(null, encodeTa, encodeVa), value.arg2),
        ];
    }
    Morphir_IR_Value.encodeRecord = encodeRecord;
    class Reference {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "Reference";
        }
    }
    Morphir_IR_Value.Reference = Reference;
    function decodeReference(decodeVa, input) {
        codecs.preprocessCustomTypeVariant("Reference", 2, input);
        return new Reference(decodeVa(input[1]), FQName_1.Morphir_IR_FQName.decodeFQName(input[2]));
    }
    Morphir_IR_Value.decodeReference = decodeReference;
    function encodeReference(encodeVa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            FQName_1.Morphir_IR_FQName.encodeFQName(value.arg2),
        ];
    }
    Morphir_IR_Value.encodeReference = encodeReference;
    class Tuple {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "Tuple";
        }
    }
    Morphir_IR_Value.Tuple = Tuple;
    function decodeTuple(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("Tuple", 2, input);
        return new Tuple(decodeVa(input[1]), codecs.decodeList(Morphir_IR_Value.decodeValue.bind(null, decodeTa, decodeVa), input[2]));
    }
    Morphir_IR_Value.decodeTuple = decodeTuple;
    function encodeTuple(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            codecs.encodeList(Morphir_IR_Value.encodeValue.bind(null, encodeTa, encodeVa), value.arg2),
        ];
    }
    Morphir_IR_Value.encodeTuple = encodeTuple;
    class Unit {
        constructor(arg1) {
            this.arg1 = arg1;
            this.kind = "Unit";
        }
    }
    Morphir_IR_Value.Unit = Unit;
    function decodeUnit(decodeVa, input) {
        codecs.preprocessCustomTypeVariant("Unit", 1, input);
        return new Unit(decodeVa(input[1]));
    }
    Morphir_IR_Value.decodeUnit = decodeUnit;
    function encodeUnit(encodeVa, value) {
        return [value.kind, encodeVa(value.arg1)];
    }
    Morphir_IR_Value.encodeUnit = encodeUnit;
    class UpdateRecord {
        constructor(arg1, arg2, arg3) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.arg3 = arg3;
            this.kind = "UpdateRecord";
        }
    }
    Morphir_IR_Value.UpdateRecord = UpdateRecord;
    function decodeUpdateRecord(decodeVa, decodeTa, input) {
        codecs.preprocessCustomTypeVariant("UpdateRecord", 3, input);
        return new UpdateRecord(decodeVa(input[1]), Morphir_IR_Value.decodeValue(decodeTa, decodeVa, input[2]), codecs.decodeDict(Name_1.Morphir_IR_Name.decodeName, Morphir_IR_Value.decodeValue.bind(null, decodeTa, decodeVa), input[3]));
    }
    Morphir_IR_Value.decodeUpdateRecord = decodeUpdateRecord;
    function encodeUpdateRecord(encodeVa, encodeTa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Morphir_IR_Value.encodeValue(encodeTa, encodeVa, value.arg2),
            codecs.encodeDict(Name_1.Morphir_IR_Name.encodeName, Morphir_IR_Value.encodeValue.bind(null, encodeTa, encodeVa), value.arg3),
        ];
    }
    Morphir_IR_Value.encodeUpdateRecord = encodeUpdateRecord;
    class Variable {
        constructor(arg1, arg2) {
            this.arg1 = arg1;
            this.arg2 = arg2;
            this.kind = "Variable";
        }
    }
    Morphir_IR_Value.Variable = Variable;
    function decodeVariable(decodeVa, input) {
        codecs.preprocessCustomTypeVariant("Variable", 2, input);
        return new Variable(decodeVa(input[1]), Name_1.Morphir_IR_Name.decodeName(input[2]));
    }
    Morphir_IR_Value.decodeVariable = decodeVariable;
    function encodeVariable(encodeVa, value) {
        return [
            value.kind,
            encodeVa(value.arg1),
            Name_1.Morphir_IR_Name.encodeName(value.arg2),
        ];
    }
    Morphir_IR_Value.encodeVariable = encodeVariable;
})(Morphir_IR_Value = exports.Morphir_IR_Value || (exports.Morphir_IR_Value = {}));
