"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getModules = exports.lookupModuleDefinition = exports.lookupPackageDef = exports.lookupPackageName = exports.fromDistribution = exports.toDistribution = exports.Morphir = void 0;
const Distribution_1 = require("./generated/morphir/ir/Distribution");
const Morphir_1 = require("./generated/Morphir");
Object.defineProperty(exports, "Morphir", { enumerable: true, get: function () { return Morphir_1.Morphir; } });
function toDistribution(text) {
    let data = JSON.parse(text);
    if (data["formatVersion"] != 3) {
        throw "Unsupported morphir-ir.json format";
    }
    return Distribution_1.Morphir_IR_Distribution.decodeDistribution(data["distribution"]);
}
exports.toDistribution = toDistribution;
function fromDistribution(distro) {
    return Distribution_1.Morphir_IR_Distribution.encodeDistribution(distro);
}
exports.fromDistribution = fromDistribution;
function capitalize(str) {
    return str.substring(0, 1).toUpperCase() + str.substring(1).toLowerCase();
}
function lookupPackageName(distro) {
    switch (distro.kind) {
        case "Library":
            return distro.arg1;
    }
}
exports.lookupPackageName = lookupPackageName;
function lookupPackageDef(distro) {
    switch (distro.kind) {
        case "Library":
            return distro.arg3;
    }
}
exports.lookupPackageDef = lookupPackageDef;
function lookupModuleDefinition(moduleName, packagDef) {
    return packagDef.modules.get(moduleName).value;
}
exports.lookupModuleDefinition = lookupModuleDefinition;
function getModules(distro) {
    switch (distro.kind) {
        case "Library":
            return distro.arg3.modules;
    }
}
exports.getModules = getModules;
